//    

#include <stdio.h>
#include "in.cpp"

void Poly (float a[], float x[], float y[], int n)
{		//====    a[] ====//
	int i, j, t, k;
	float *c=new float[n], d, e;
		//=====     c[] =====//
	for (i=0; i<n; i++) 
	{
		for (c[0]=1, t=k=0; k<n; k++)		//  c[]
			if (k != i)
			{								//  
				d=1/(x[i]-x[k]);  
				e=-x[k]*d;
				c[t+1]=c[t]*d;
				for (j=t; j>0; j--)
					c[j]=c[j-1]*d+c[j]*e;
				c[0] *= e;
				t++;
			}								//    
		for (j=0; j<n; j++)
			a[j] += c[j]*y[i];
	}
	printf ("\n\n Polynomial coefficients :\n");
	for (i=0; i<n; i++)
		printf ("\n a[%d]=%8.5g",i,a[i]);
}

const int MIN=0, MAX=10;			//  

void main ()
{
	float *x, *y, *a, c, b;
	int i, j, k, n;
	printf ("\n\tNumber of Interpolation Nodes (<10):\n");
	n = in (MIN, MAX);				//   
	a = new float[n];
	x = new float[n];
	y = new float[n];

	printf ("\n The Nodes :\n");
	for (i=0; i<n; i++)
	{								//  
		printf ("\nx[%d]= ",i+1);	scanf ("%f",x+i);
		printf ("y[%d]= ",i+1);		scanf ("%f",y+i);
		a[i]=0.;
	}

	Poly (a, x, y, n);				//   
									//    
	printf ("\n\n Check at nodes gives:\n");

	for (i=0; i<n; i++)				//   
	{						//======     i- 
		for (c=0., j=0; j<n; j++)
		{
			for (b=1., k=0;  k<j;  k++, b *= x[i])
				;					//   
			c += a[j]*b;
		}
		printf ("\n x[%d]=%5.2f\ty=%8.5f",i+1,x[i],c);
	}
	puts("\n\n");
}
