//   
//    

#include <stdio.h>
#include <stdlib.h>

template <class T>
void QuickSort(T *ar, int l, int r)
{
	T mid, temp;

	int i = l, j = r;				//     
	mid = ar[(l + r) / 2];			//  
	do								// ,  
	{
				//   ,   (  )
		while (ar[i] < mid) i++;
		while (mid < ar[j]) j--;
		if (i <= j)					//   ,
		{							//   
			temp = ar[i];
			ar[i++] = ar[j];
			ar[j--] = temp;
		}
	}
	while (i <= j);						//   
	if (l < j)							//     ,
		QuickSort (ar, l, j);			//   
	if (i < r)							//     ,
		QuickSort (ar, i, r);			//   
}

#define N 21				//    

void main()
{
	double ar[N];			//  
							//     
	//int ar[N];			//     
	puts("\n\nArray before Sorting\n");
	for (int i=0; i<N; i++)
	{
		ar[i] = rand()%20;	//  
		if (i%7==0)
			printf ("\n");
		printf ("%2.0f\t",ar[i]);
		//printf ("%d\t",ar[i]);	//    
	}

	QuickSort(ar,0,N-1);
	
	puts("\n\nAfter Sorting\n");
	for (i=0; i<N; i++)
	{
		if (i%7==0)
			printf ("\n");
		printf ("%2.0f\t",ar[i]);
		//printf ("%d\t",ar[i]);
	}
	puts("\n");
}
