//    
//    
//   ,     (  -  0)
//    -1 ?

#include <stdio.h>
#include <conio.h>
#include "in.cpp"

	// ,  n ,    d
int invert (int v, unsigned n, unsigned d)
{
	return v^(~(~0<<n)<<d);
}

	//  
unsigned MaxUnsigned, Digits;		
int MaxInt, MinInt;

	//      n 
void showbit (int n)				
{	
	printf("\n %d Digits:   %d=",Digits,n);
									//   
	for (unsigned i=0; i<Digits; i++, n<<=1)
		if (n & MinInt)	
			putchar('1');
		else					
			putchar('0');
	
	if (!getch())
		getch();
}

void main()
{									
	unsigned u;
	int i, j;
	MaxUnsigned = (unsigned)~0;		//  
	MaxInt = MaxUnsigned>>1;
	MinInt = ~MaxInt;
	
	printf ("\n Fundamental Compiler Dependent Constants\n"
			"\nunsigned int max = %u"
			"\nsigned  int max = %d"
			"\nsigned  int min =%d\n",
			MaxUnsigned,MaxInt,MinInt);
	printf ("\nunsigned (~0) = %u"
			"\nint   (~0) = %d"
			"\n~0>>1     = %d\n",~0,~0,~0>>1);
	
		//===    unsigned ===//
	for (Digits=1, u=MaxUnsigned; (u>>=1)>0; Digits++)
			;				//   
	
	printf ("\nunsigned digits = %d bits"
			"\nsizeof(unsigned) = %d bytes\n",
			Digits,sizeof(unsigned));
	
		//===    ===//
	puts("\n\n\tBinary codes (0 - to Leave):");
	do
	{
		i=in (MinInt, MaxInt);		// 
		showbit (i);				// 
		j=invert (i, 2, 4);			// 
		puts("\n\n\t After the 4th and 5th bits inversion:");
		showbit (j);				// 
	}
	while (i);
	puts("\n\n");
}
