//     

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "in.cpp"

typedef unsigned int uint;		//     

	//        
typedef bool (*order)(void*, void*);

struct Man				// ,    
{
	uint Age;			//  
	char *Name;			//      
	Man *Next;			//      Man
};

		//        
uint EnterStrings(char**&);

void Sort (char*, uint, uint, order);		//  

		//       
bool Double_ord (void *p, void *q)
{		//  
	return *(double*)p <= *(double*)q;
}

bool Int_ord (void *p, void *q)
{		//  
	return *(int*)p <= *(int*)q;
}

bool Str_ord (void *p, void *q)
{		//   
	return strcmp(*(char**)p, *(char**)q) <= 0;
}

bool Name_ord (void *p, void *q)
{		//    Man
	return strcmp(((Man*)p)->Name,((Man*)q)->Name) <= 0;
}

bool Age_ord (void *p, void *q)
{		//    Man
	return ((Man*)p)->Age <= ((Man*)q)->Age;
}

#define Mess puts("\nPress a key");		getch()

void main ()
{											//  
	double db [5] = {18., 0., -4.2, 6.7, 14.4};
	
	char* st [5] = {"One","Two words", "Three separate words",
					"Four","Longest string in this array"};
	
	int in [7] = {36, 2, 1, -8, 24, 5, 30};
	
	Man m[5] = {{50,"Alex",m+1},{5,"Maria",m+2},
				{40,"Galina Petrovna",m+3},
				{28,"Roman",m+4}, {23,"Alina",m}};
	order f;						//    
	uint i;
									//   
	f = Double_ord;					//     
	Sort ((char*) db, sizeof(double), 5, f);
	puts (" Array of floats after sorting");
	for (i=0; i<5; i++)
		printf ("\n %d.  %5.2f",i+1,db[i]);
	Mess;

	f = Int_ord;					//   
	Sort ((char*) in, sizeof(int), 7, f);
	puts ("\n Array of integers after sorting");
	for (i=0; i<7; i++)
		printf ("\n %d.  %d",i+1,in[i]);
	Mess;
									//   
	Sort ((char*)st, sizeof(char*), 5, Str_ord);
	puts ("\n Array of character strings after sorting");
	for (i=0; i<5; i++)
		printf ("\n %d.  %s",i+1,st[i]);
	Mess;
	
									//    Man  
	Sort ((char*)m, sizeof(Man), 5, Age_ord);
	puts ("\n Array of Man after sorting by age");
	for (i=0; i<5; i++)
		printf ("\n %d.  %s  %u",i+1,m[i].Name,m[i].Age);
	Mess;
									//    Man  
	Sort ((char*)m, sizeof(Man), 5, Name_ord);
	puts ("\n Array of Man after sorting by name");
	for (i=0; i<5; i++)
		printf ("\n %d.  %s  %u",i+1,m[i].Name,m[i].Age);
									//    
	char **strings;
	uint n = EnterStrings(strings);
	if (n)
	{
		Sort ((char*)strings, sizeof(char*), n, Str_ord);
		puts ("\n Dynamic array of strings after sorting");
		for (i=0; i<n; i++)
			printf ("\n %d.  %s",i+1,strings[i]);
	}
	puts ("\n\n");
}
								//     
uint EnterStrings(char**& s)
{
	puts ("\n\nHow many strings are you going to enter : ");
	uint n = (uint)in(0,100);
	if (!n)
		return 0;
	s = new char* [n];
	char buf[82] = { 80 }, *temp;
	puts ("\nEnter them now\n");
	for (uint i=0; i<n; i++)
	{
		temp = cgets(buf);
		s[i] = strcpy(new char[buf[1]+1], temp);
	}
	return n;
}

								//    
void Sort (char *first, uint n, uint N, order ord)
{
	bool sorted;				//   
	uint i;
	char *p1, *p2, *c, t;
								//    
	for (sorted=false, c=first+n*(N-1);  !sorted;  c-=n)
		for (sorted=true, p1=first, p2=p1+n;
				p1<c;  p1+=n, p2+=n)			//  
			if (!(*ord)(p1, p2))				//  
				for (sorted=false, i=0;  i<n;  i++)
				{
					t=p1[i]; p1[i]=p2[i];  p2[i]=t;
				}
}
